@echo off
        rem     in case ANSI driver:
        rem     set screen color to black on bright green
    wbat pal ! font ! cls ! ansi? [0;30;42m

        set name=Horst Schaeffer
        set city=Munich

        rem ------------------------------------------------------------
        rem     start box using default source file: DEMO.TXT
    wbat fill (+green on yellow) " " +2
    wbat box @:start
        rem     El 1: start, 2: exit, 255: error
        if errorlevel 255 echo Error running WBAT box @:start
        if errorlevel 255 pause
        if errorlevel 2 goto exit

        rem     mpos controls current bar position in main menu
        set mpos=0

:main menu =============================================================

    wbat cls ! menu @:index #%mpos%+1
    call wtemp.bat

        rem     keep mpos: bar position=errorlevel
        set mpos=%?%
        set wpos=

        goto %wbat%  (go label = first word of menu item)

:general information ---------------------------------------------------

        rem     display text pages with "quick" buttons
    wbat cls ! text 2,4 @:general    ! box 25,55 continue,back
        if errorlevel 2 goto main

    wbat cls ! text 2,4 @:gen_layout ! box 23,55 continue,back
        if errorlevel 2 goto main

    wbat cls ! text 2,4 @:gen_return ! box 25,65 back
        goto main

:dialog box ------------------------------------------------------------

    wbat cls
    wbat box @:dialog_menu #%wpos%
    call wtemp.bat
        if %wbat%==back goto main
        set wpos=%?%
        set spos=
        goto %wbat%
        rem     go label according to selected item

:Command ...............................................................

    wbat cls ! text 2,4 @:syntax

:comm_rpt ......... this menu box is always shown on the following pages

    wbat menu 25,70 @:command_spec #%spos%
    call wtemp.bat
        if %wbat%==back goto dialog
        set spos=%?%

        rem     show text by label from command_spec menu (prefix: com_)

    wbat cls ! text 2,4 @:com_%wbat%
        goto comm_rpt

:Elements ..............................................................

    wbat cls ! text 2,4 @:layout

:elem_rpt

    wbat menu 25,70 @:control_elements #%spos%
    call wtemp.bat
        if %wbat%==back goto dialog
        set spos=%?%
    wbat cls ! text 2,4 @:ctl_%wbat%
        goto elem_rpt

:Style .................................................................

    wbat cls ! text 2,4 @:style

:st_rpt

    wbat menu 25,70 @:style_menu #%spos%
    call wtemp.bat
        if %wbat%==back goto dialog
        set spos=%?%
    wbat cls ! text 2,4 @:st_%wbat%
        goto st_rpt


:Handling ..............................................................

    wbat cls ! text 2,4 @:handling

:keys_rpt
    wbat menu 25,70 @:keys #%spos%
    call wtemp.bat
        if %wbat%==back goto dialog
        set spos=%?%
    wbat cls ! text 2,4 @:key_%wbat%
        goto keys_rpt

:Variables .............................................................

    wbat cls ! text 2,4 @:variables

:var_rpt
    wbat menu 25,70 @:var_menu #%spos%
    call wtemp.bat
        if %wbat%==back goto dialog
        set spos=%?%

    wbat cls ! text 2,4 @:var_%wbat%
        if %wbat%==WBAT goto var_rpt
    wbat box 22,65 (white on +blue) more
    wbat cls ! text 2,4 (blue on +green) @:var_%wbat%_cont
        goto var_rpt

:Testing ...............................................................

    wbat cls ! text 2,4 @:examples

:exm_rpt
    wbat menu 25,70 @:example_menu #%spos%
    call wtemp.bat
        if %wbat%==back goto dialog
        set spos=%?%

        rem     example number (1/2) from %wbat%
        set X#=%wbat%
        set WRB=
    wbat cls
        rem     with debug box after test box
    wbat box @:example_%X#%
    call wdebug.bat  wtemp.bat
    wbat text 3,5 "This is the Layout"
    wbat text 9,22 (black on white) @:example_%X#%
    wbat box 20,60 ok
        goto exm_rpt

:screens - text displays -----------------------------------------------

    wbat cls
    wbat box @:screen_menu #%wpos%
    call wtemp.bat
        if %wbat%==back goto main
        set wpos=%?%
        set spos=
        goto S_%wbat%

:s_cls    ..............................................................

    wbat cls ! text 2,4 @:cls ! box 21,65 ANSI?,back
    if errorlevel 2 goto screens

:s_ansi?
    wbat ansi?
        if not errorlevel 1 goto s_cont
    wbat cls ! text 2,4 @:no_ansi
    wbat box 21,65 continue,skip
    if errorlevel 2 goto screens
:s_cont
    wbat cls ! text 2,4 @:scr_ansi ! box 21,65 ok
    goto screens

:s_fill ................................................................

    wbat cls ! text 2,4 @:fill

:fill_rpt
    wbat menu 25,58 @:fill_commands #%spos%
    call wtemp.bat
        if %wbat%==back goto screens
        set spos=%?%
    wbat cls
        goto f_%wbat%

:f_clear
    wbat text 2,4 @:fill_clear ! fill 20,7 (4,65) (red on +brown)
        goto fill_rpt

:f_strings
    wbat text 2,4 @:fill_strings
    wbat fill 5,55 (3,22) (+white on blue) ""
    wbat fill 9,55 (3,22) (+white on blue) ""
    wbat fill 13,55 (4,22) (+cyan on blue) " Wbat *"
    wbat fill 2,78 (23,1) (+white on blue) ""
        goto fill_rpt

:f_shifting
    wbat text 2,4 @:fill_shift
    wbat fill 7,55 (4,22) (+red on cyan) "Wbat * " +2
    wbat fill 12,55 (3,22) (+cyan on red) ""
    wbat fill 16,55 (5,22) (+cyan on red) "" +2
    wbat fill 2,78 (23,1) ( red on yellow) "WBAT*" +1
        goto fill_rpt

:s_cursor  .............................................................

    wbat cls ! text 2,4 @:cursor ! box 21,65 ok
        goto screens

:s_text ................................................................

    wbat cls ! text 2,4 @:text

:text_rpt
    wbat menu 25,70 @:txt_menu #%spos%
    call wtemp.bat
        if %wbat%==back goto screens
        set spos=%?%
    wbat cls ! text 2,4 @:txt_%wbat%
        if not %wbat%==display goto text_rpt
    wbat text 19,4  (+ white on red) @:txt_ex1
    wbat text 19,32 (+ white on red) @:txt_ex2
        goto text_rpt

:color palette and font ------------------------------------------------

    wbat cls
    wbat box @:font_pal #%wpos%
    call wtemp.bat
        if %wbat%==back goto main
        set wpos=%?%
    wbat cls ! text 2,4 @:style_%wbat% ! box 20,65 ok
    goto color

:test colors -----------------------------------------------------------

    call color.bat
    goto main

:quick reference -------------------------------------------------------

    wbat cls
    wbat menu @:quick_ref #%wpos%
    call wtemp.bat
        if %wbat%==return goto main
        set wpos=%?%
    wbat cls! text 2,4 @:ref_%wbat% ! box 22,65 ok
    goto quick

:ini    ----------------------------------------------------------------

    wbat cls
    wbat box @:setup #%wpos%
    call wtemp.bat
        if %wbat%==back goto main
        set wpos=%?%
        set spos=
        goto ini_%wbat%

:ini_WBATINI    ........................................................

    wbat cls ! text 2,4 @:set_WBATINI ! box 25,68 continue
    wbat cls ! text 2,2 (black on white) @WBAT.INI
    wbat box 25,68 OK
    goto ini

:ini_file       ........................................................

    wbat cls ! text 2,4 @:set_file
:ini_rpt
    wbat menu 20,60 @:set_menu #%spos%
    call wtemp.bat
        if %wbat%==back goto ini
        set spos=%?%
    wbat cls ! text 2,4 @:path_%wbat%
        goto ini_rpt

:ini_installation ......................................................

    wbat cls ! text 2,4 @:set_%wbat% ! box 25,68 ok
    goto ini

:tips   ----------------------------------------------------------------

    wbat cls
    wbat menu @:tips_menu #%wpos%
    call wtemp.bat
        if %wbat%==return goto main
        set wpos=%?%
    wbat text 2,4 @:tip_%wbat% ! box 25,70 ok
        goto tips

:exit
for %%a in (wbat mpos x# name city country wcb1 wcb2 wrb wpos spos ?) do set %%a=
wbat cls (white on black) ! box "Reset font and palette?" yes,no #2
if not errorlevel 2 mode co80
if exist wtemp.bat del wtemp.bat
:end
